# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2010 Filipe Goncalves the.wa.syndrome@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gtk
import urllib2
from threading import Thread
from tagplayer.helpers import get_builder

import gettext
from gettext import gettext as _
gettext.textdomain('tagplayer')

import logging
log = logging.getLogger("TagPlayer")

class NowplayingDialog(gtk.Dialog):
	__gtype_name__ = "NowplayingDialog"

	def __new__(cls):
		"""Special static method that's automatically called by Python when 
		constructing a new instance of this class.
		
		Returns a fully instantiated NowplayingDialog object.
		"""
		builder = get_builder('NowplayingDialog')
		new_object = builder.get_object('nowplaying_dialog')
		new_object.finish_initializing(builder)
		return new_object
	   
	def fill(self, info):
		"""Fills the labels with now playing info"""
		artist_url= ("http://www.last.fm/music/"+info['xesam:artist'][0]).replace(" ","+")
		track_url = (artist_url+"/_/"+info['xesam:title']).replace(" ","+")
		link_but = self.builder.get_object("artist_link")
		link_but.set_label(info['xesam:artist'][0])
		link_but.set_uri(artist_url)
		link_but = self.builder.get_object("track_link")
		link_but.set_label(info['xesam:title'])
		link_but.set_uri(track_url)
		
		if 'mpris:artUrl' in info:
			Thread(target=self.get_album_cover, args=(info['mpris:artUrl'],)).start()
	 

	def get_album_cover(self, url):
		response=urllib2.urlopen(url)
		loader=gtk.gdk.PixbufLoader()
		loader.write(response.read())
		loader.close()
		self.builder.get_object('image1').set_from_pixbuf(loader.get_pixbuf())

	def finish_initializing(self, builder):
		"""Called when we're finished initializing.

		finish_initalizing should be called after parsing the ui definition
		and creating a NowplayingDialog object with it in order to
		finish initializing the start of the new NowplayingDialog
		instance.
		"""
		# Get a reference to the builder and set up the signals.
		self.builder = builder
		self.builder.connect_signals(self)

	def ok(self, widget, data=None):
		"""The user has elected to save the changes.

		Called before the dialog returns gtk.RESONSE_OK from run().
		"""
		pass


if __name__ == "__main__":
	dialog = NowplayingDialog()
	dialog.show()
	gtk.main()
