#!/usr/bin/env python
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import urllib, urllib2, json
import hashlib

import logging
log = logging.getLogger(__name__)

class LastFM:
	'''
		Last.fm Rest API wrapper
		It is incomplete, and only for specific use with TagPlayer project
	'''
	
	__api_url='http://ws.audioscrobbler.com/2.0/'
	__api_key = 'c64773563d5cd1491060f271ae3d999b'
	__api_secret = '2bd3b29cf2b69c3963175cb9a01b63b5'
	__client_id = 'tag'
	__client_version = '1.0'

			
	@staticmethod
	def __request_read(params):
		params['format'] = 'json'
		req = reduce(lambda  a,b: '{0}&{1}'.format(a,b), map(lambda x: '{0}={1}'.format(x, params[x]), params))
		req_string = '{0}?{1}'.format(LastFM.__api_url, req)
#		print req_string
		response = urllib2.urlopen(req_string).read()
		response_dict = json.loads(response)		
		if 'error' in response_dict.keys():
			raise LastFMException(response_dict)
		return response_dict
	
	@staticmethod
	def __request_write(params):
		params['format'] = 'json'
		req = reduce(lambda  a,b: '{0}&{1}'.format(a,b), map(lambda x: '{0}={1}'.format(x, params[x]), params))
#		print 'POST DATA\n'+req+'\n'+('¨'*80)
		response = urllib2.urlopen(LastFM.__api_url, req).read()
		response_dict = json.loads(response)
		if 'error' in response_dict.keys():
#			print response_dict
			raise LastFMException(response_dict)
		return response_dict
		
	@staticmethod
	def scrobble(session_key, metadata):
		#metadata needs track, timestamp, artist, duration?(from gstreamer),
		if type(metadata) == dict:
			metadata = [metadata]
		params = {}
		params['method'] = 'track.scrobble'
		params['sk'] = session_key
		params['api_key'] = LastFM.__api_key
		counter = 0
		for m in metadata:
			params['track[%s]' % str(counter)] = m['title']
			params['artist[%s]' % str(counter)] = m['artist']
			params['timestamp[%s]' % str(counter)] = m['timestamp']
			params['duration[%s]' % str(counter)] = m['duration']
			counter += 1
		params['api_sig'] = LastFM.__api_sig(params)
		counter -= 1
		while counter >= 0:
			params['track[%s]' % str(counter)] = LastFM.__escape(params['track[%s]' % str(counter)])
			params['artist[%s]' % str(counter)] = LastFM.__escape(params['artist[%s]' % str(counter)])
			counter -= 1
		return LastFM.__request_write(params)
		
	@staticmethod
	def updateNowPlaying(session_key, metadata):
		params={}
		params['method'] = 'track.updatenowplaying'
		params['sk'] = session_key
		params['api_key'] = LastFM.__api_key
		params['track'] = metadata['title']
		params['artist'] = metadata['artist']
		params['api_sig'] = LastFM.__api_sig(params)
		params['track'] = LastFM.__escape(params['track'])
		params['artist'] = LastFM.__escape(params['artist'])
		return LastFM.__request_write(params)
		

	@staticmethod
	def get_token():
		params={}
		params['method'] = 'auth.gettoken'
		params['api_key'] = LastFM.__api_key
		return LastFM.__request_read(params)['token']

	@staticmethod
	def auth_url(token):
		return 'http://www.last.fm/api/auth/?api_key={0}&token={1}'.format(LastFM.__api_key, token)
	
	@staticmethod
	def get_session(token):
		params={}
		params['method'] = 'auth.getsession'
		params['token'] = token
		params['api_key'] = LastFM.__api_key
		params['api_sig'] = LastFM.__api_sig(params)
		return LastFM.__request_read(params)['session']
	
	@staticmethod
	def __api_sig(params):
		sig = reduce(lambda a,b: a+b, map(lambda x: str(x)+str(params[x]), sorted(params)))
#		print sig
		return hashlib.md5(sig+str(LastFM.__api_secret)).hexdigest()

	##Demo authenticated method	
	@staticmethod
	def user_rec(sk):
		params={}
		params['method'] = 'user.getrecommendedartists'
		params['sk'] = sk
		params['api_key'] = LastFM.__api_key
		params['limit'] = 1
		params['api_sig'] = LastFM.__api_sig(params)
		return LastFM.__request_read(params)
	
	
	@staticmethod
	def get_artist_top_tags(artist):
		params={}
		params['method'] = 'artist.gettoptags'
		params['api_key'] = LastFM.__api_key
		params['autocorrect'] = 1
		params['artist'] = LastFM.__escape(artist)
		lfm_artist = LastFM.__request_read(params)
		try:
			lfm_artist['toptags']['tag']
		except:
			return []
		return filter(lambda x: x[1]>0,map(lambda x: (x['name'],int(x['count'])) , lfm_artist['toptags']['tag']))
	
	@staticmethod
	def __escape(s):
		return urllib.quote_plus(s.encode('utf-8'))
#		for x in [(' ','+'),('&','%26'),('[','%5B'),(']','%5D')]:#TODO complete
#			s = s.replace(x[0],x[1])
#		return s

	@staticmethod
	def get_track_info(track, artist):
		params={}
		params['method'] = 'track.getinfo'
		params['api_key'] = LastFM.__api_key
		params['autocorrect'] = 1
		params['artist'] = LastFM.__escape(artist)
		params['track'] = LastFM.__escape(track)
		lfm_track = LastFM.__request_read(params)['track']
		result = {'id': lfm_track['id'], 'url': lfm_track['url'], 'artist': lfm_track['artist']['name'], 'title': lfm_track['name']}
		try:
			result['album_art'] = filter(lambda x: x['size'] == 'small', lfm_track['album']['image'])[0]['#text']
		except:
			pass
		return result
		
class LastFMException(Exception):
	'''
		Last.fm API error handling
	'''
	#TODO error code specific handling according to http://www.last.fm/api/errorcodes
	def __init__(self, value):
		'''
			Constructor. self.value is a dictionary with the error code and message
		'''
		self.value = value
	def __str__(self):
		return repr(self.value['message'])

#RUN AS STANDALONE
if __name__ == '__main__':
	print LastFM.get_artist_top_tags('Blood Red Shoes')
	print LastFM.get_track_info('Conselhos de Avô','B Fachada')
