#!/usr/bin/python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2010 Filipe Goncalves the.wa.syndrome@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

"""Code to add AppIndicator."""

import gtk

from tagplayer.helpers import get_media_file

import gettext
from gettext import gettext as _
gettext.textdomain('tagplayer')

import appindicator

import logging
log = logging.getLogger("TagPlayer")

class Indicator:
    def __init__(self,window):
        self.indicator = appindicator.Indicator('tagplayer','sound-icon',appindicator.CATEGORY_APPLICATION_STATUS)#TODO PUT FULL PATH TO ICON... should be /usr/share/myapp/media/logo.png
        self.indicator.set_status(appindicator.STATUS_ACTIVE)
    
        #Can use self.icon once appindicator python api supports custom icons.
#        icon = get_media_file("logo.png")
#        self.indicator.set_icon(icon)
 
        #Uncomment and choose an icon for attention state. 
        #self.indicator.set_attention_icon("ICON-NAME")
        
        self.menu = gtk.Menu()

        # Add items to Menu and connect signals. 
        # Can access methods from bin/tagplayer using window
        
        # Add more items here
        
        self.next = gtk.MenuItem(gettext.gettext("Next"))
        self.next.connect("activate", window.skip)
        self.next.show()
        self.menu.append(self.next)
        
        self.play = gtk.MenuItem(gettext.gettext("Play/Pause"))
        self.play.connect("activate", window.play_pause)
        self.play.show()
        self.menu.append(self.play)
        
        #Adding preferences button 
        #window represents the main Window object of your app
#        self.preferences = gtk.MenuItem(gettext.gettext("Preferences"))
#        self.preferences.connect("activate", window.preferences)
#        self.preferences.show()
#        self.menu.append(self.preferences)

        self.quit = gtk.MenuItem(gettext.gettext("Quit"))
        self.quit.connect("activate", window.quit)
        self.quit.show()
        self.menu.append(self.quit)
        
        self.menu.show()
        self.indicator.set_menu(self.menu)
        log.info('Done Indicator!')
    
def new_application_indicator(window):
    ind = Indicator(window)
    return ind.indicator
